"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TransactionDetails(ProtocolElement):
    """
    Details about the content of a transaction and some logs.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "history",
        "metadata",
        "numberOfElements",
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0

        return {
            "history": cva_1_3_0.TransactionStatusChange,
            "metadata": cva_1_3_0.InjectionMetadata,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0

        return {
            "org.gel.models.cva.avro.TransactionStatusChange": cva_1_3_0.TransactionStatusChange,
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_3_0.InjectionMetadata,
            "org.gel.models.cva.avro.TransactionDetails": cva_1_3_0.TransactionDetails,
        }

    __slots__ = [
        "history",
        "metadata",
        "numberOfElements",
        "type",
    ]

    def __init__(
        self,
        history,
        metadata,
        numberOfElements,
        type,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_3_0.TransactionDetails model.

        :param history:
            Messages
        :type history: list[TransactionStatusChange]
        :param metadata:
            Metadata on the injection data
        :type metadata: InjectionMetadata
        :param numberOfElements:
            The number of elements contained in the transaction
        :type numberOfElements: int
        :param type:
            The type of the transaction (e.g.:
            org.gel.models.cva.avro.InterpretedGenomeInject)
        :type type: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
